diff --git a/src/backend/utils/cache/catcache.c b/src/backend/utils/cache/catcache.c
index 64776e3..0d807c3 100644
--- a/src/backend/utils/cache/catcache.c
+++ b/src/backend/utils/cache/catcache.c
@@ -1363,17 +1800,58 @@ SearchCatCacheMiss(CatCache *cache,
 								  nkeys,
 								  cur_skey);
 
-	ct = NULL;
+	local_ct = NULL;
 
 	while (HeapTupleIsValid(ntp = systable_getnext(scandesc)))
 	{
-		ct = CatalogCacheCreateEntry(cache, ntp, arguments,
-									 hashValue, hashIndex,
-									 false);
-		/* immediately set the refcount to 1 */
-		ResourceOwnerEnlargeCatCacheRefs(CurrentResourceOwner);
-		ct->refcount++;
-		ResourceOwnerRememberCatCacheRef(CurrentResourceOwner, &ct->tuple);
+		if (cache->cc_type == CC_REGULAR)
+			local_ct = CatalogCacheCreateEntry(cache, ntp, arguments,
+											   hashValue, hashIndex,
+											   false, NULL);
+		else if (cache->cc_type == CC_SHAREDLOCAL)
+		{
+			/* create global cache entry first then local one */
+
+			global_hashIndex = HASH_INDEX(hashValue,
+										  ((CatCache *)cache->gcp)->cc_nbuckets);
+
+			/* set the refcount of global cache entry to 1 here */
+			gct = (GlobalCatCTup *)
+				CatalogCacheCreateEntry((CatCache *)cache->gcp, ntp, arguments,
+										hashValue, global_hashIndex,
+										false, NULL);
+
+			/* If tuple is uncommitted, it's not located in GlobalCatCache */
+			if (gct)
+				handle = gct->gct_handle;
+			else
+				handle = NULL;
+
+			local_ct = CatalogCacheCreateEntry(cache, ntp, arguments,
+											   hashValue, hashIndex,
+											   false, handle);
+
+		}
+		else
+			elog(FATAL, "The target of CatCacheSearchMiss is not SHAREDGLOBAL");
+
+		/*
+		 * If local cache entry is a pointer to global entry, keep refcount to
+		 * zero because there is no need to protect tuple which doesn't exist.
+		 */
+		if (cache->cc_type == CC_REGULAR
+			||(cache->cc_type == CC_SHAREDLOCAL &&
+			   !((LocalCatCTup *)local_ct)->lct_committed))
+		{
+			/* immediately set the local refcount to 1 */
+			ResourceOwnerEnlargeCatCacheRefs(CurrentResourceOwner);
+			local_ct->refcount++;
+			ResourceOwnerRememberCatCacheRef(CurrentResourceOwner, &local_ct->tuple);
+
+			CACHE_elog(DEBUG2, "SearchCatCacheMiss local refcount is bumped: %s, %d tuple %p",
+					   local_ct->my_cache->cc_relname, local_ct->refcount,
+					   &local_ct->tuple);
+		}
 		break;					/* assume only one match */
 	}
 
@@ -1391,14 +1869,14 @@ SearchCatCacheMiss(CatCache *cache,
 	 * gets created later.  (Bootstrap doesn't do UPDATEs, so it doesn't need
 	 * cache inval for that.)
 	 */
-	if (ct == NULL)
+	if (local_ct == NULL)
 	{
 		if (IsBootstrapProcessingMode())
 			return NULL;
 
-		ct = CatalogCacheCreateEntry(cache, NULL, arguments,
-									 hashValue, hashIndex,
-									 true);
+		local_ct = CatalogCacheCreateEntry(cache, NULL, arguments,
+										   hashValue, hashIndex,
+										   true, NULL);
 
 		CACHE_elog(DEBUG2, "SearchCatCache(%s): Contains %d/%d tuples",
 				   cache->cc_relname, cache->cc_ntup, CacheHdr->ch_ntup);
@@ -1422,7 +1900,18 @@ SearchCatCacheMiss(CatCache *cache,
 	cache->cc_newloads++;
 #endif
 
-	return &ct->tuple;
+
+	if (cache->cc_type == CC_REGULAR)
+		tuple = &local_ct->tuple;
+	else if (cache->cc_type == CC_SHAREDLOCAL)
+	{
+		if (gct)
+			tuple = &((CatCTup *)gct)->tuple;
+		else
+			tuple = &local_ct->tuple;
+	}
+
+	return tuple;
 }
 
 /*
@@ -1439,6 +1928,7 @@ SearchCatCacheMiss(CatCache *cache,
 void
 ReleaseCatCache(HeapTuple tuple)
 {
+	CatCache *cache;
 	CatCTup    *ct = (CatCTup *) (((char *) tuple) -
 								  offsetof(CatCTup, tuple));
 
@@ -1446,8 +1936,21 @@ ReleaseCatCache(HeapTuple tuple)
 	Assert(ct->ct_magic == CT_MAGIC);
 	Assert(ct->refcount > 0);
 
-	ct->refcount--;
-	ResourceOwnerForgetCatCacheRef(CurrentResourceOwner, &ct->tuple);
+	cache = ct->my_cache;
+
+	if (cache->cc_type == CC_REGULAR ||
+		(cache->cc_type == CC_SHAREDLOCAL &&
+		 !((LocalCatCTup *)ct)->lct_committed))
+	{
+		/*
+		 * CC_REGULAR and CC_SHAREDLOCAL case.
+		 * Note that CC_SHAREDLOCAL might have uncommitted tuple locally
+		 */
+		ct->refcount--;
+		ResourceOwnerForgetCatCacheRef(CurrentResourceOwner, &ct->tuple);
+	}
+	else if (cache->cc_type == CC_SHAREDGLOBAL)
+		GlobalCatCTupDecrementAndRemove((GlobalCatCache *)cache, (GlobalCatCTup *)ct);
 
 	if (
 #ifndef CATCACHE_FORCE_RELEASE
@@ -1455,7 +1958,7 @@ ReleaseCatCache(HeapTuple tuple)
 #endif
 		ct->refcount == 0 &&
 		(ct->c_list == NULL || ct->c_list->refcount == 0))
-		CatCacheRemoveCTup(ct->my_cache, ct);
+		CatCacheRemoveCTup(cache, ct);
 }
 
 
@@ -1511,16 +2014,20 @@ SearchCatCacheList(CatCache *cache,
 {
 	Datum		v4 = 0;			/* dummy last-column value */
 	Datum		arguments[CATCACHE_MAXKEYS];
+	Datum		lct_arguments[CATCACHE_MAXKEYS];
 	uint32		lHashValue;
 	dlist_iter	iter;
 	CatCList   *cl;
 	CatCTup    *ct;
+	CatCTup    *local_ct;
+	LocalCatCTup *lct;
 	List	   *volatile ctlist;
 	ListCell   *ctlist_item;
 	int			nmembers;
 	bool		ordered;
 	HeapTuple	ntp;
 	MemoryContext oldcxt;
+	const CCFastEqualFN *cc_fastequal;
 	int			i;
 
 	/*
@@ -1570,10 +2077,60 @@ SearchCatCacheList(CatCache *cache,
 		if (cl->nkeys != nkeys)
 			continue;
 
-		if (!CatalogCacheCompareTuple(cache, nkeys, cl->keys, arguments))
+		cc_fastequal =  cache->cc_fastequal;
+		if (!CatalogCacheCompareTuple(cc_fastequal, nkeys, cl->keys, arguments))
 			continue;
 
 		/*
+		 * Cache entries may be stale. If there's invalid entry, the entry and
+		 * its list are removed or marked as dead. Moreover, we need to decrease
+		 * the refcounts of valid entries, which are already bumped.
+		 */
+		if (cache->cc_type == CC_SHAREDLOCAL)
+		{
+			CatCTup *temp_ct;
+
+			for (i = 0; i < cl->n_members; i++)
+			{
+				/* Note global refcount is raised if it's valid */
+				temp_ct = LocalCacheGetValidEntry(cl->shared_local_members[i]);
+
+				/* If it's valid, go through. If not, do clean up. */
+				if (!temp_ct)
+				{
+					LocalCatCTup *temp_lct;
+					GlobalCatCTup *temp_gct;
+
+					for (--i ; i >= 0; i--)
+					{
+						temp_lct = cl->shared_local_members[i];
+
+						/* Refcount of local entry is not increased */
+						if (!temp_lct->lct_committed || ((CatCTup *)temp_lct)->negative)
+							continue;
+
+						temp_gct = temp_lct->lct_handle->entry;
+
+						GlobalCatCTupDecrementAndRemove((GlobalCatCache *)(((CatCTup *)temp_gct)->my_cache),
+														temp_gct);
+					}
+
+					/* cl is not valid eitehr */
+					if (cl->refcount > 0)
+						cl->dead = true;
+					else
+						CatCacheRemoveCList(cache, cl);
+
+					break;
+				}
+			}
+
+			/* if last temp_ct is not valid, break dlist_foreach loop */
+			if (!temp_ct)
+				break;
+		}
+
+		/*
 		 * We found a matching list.  Move the list to the front of the
 		 * cache's list-of-lists, to speed subsequent searches.  (We do not
 		 * move the members to the fronts of their hashbucket lists, however,
@@ -1649,29 +2206,66 @@ SearchCatCacheList(CatCache *cache,
 			/*
 			 * See if there's an entry for this tuple already.
 			 */
-			ct = NULL;
-			hashValue = CatalogCacheComputeTupleHashValue(cache, cache->cc_nkeys, ntp);
+			local_ct = NULL;
+			hashValue = CatalogCacheComputeTupleHashValue(cache,
+														  cache->cc_nkeys, ntp);
 			hashIndex = HASH_INDEX(hashValue, cache->cc_nbuckets);
 
 			bucket = &cache->cc_bucket[hashIndex];
+
 			dlist_foreach(iter, bucket)
 			{
-				ct = dlist_container(CatCTup, cache_elem, iter.cur);
+				local_ct = dlist_container(CatCTup, cache_elem, iter.cur);
 
-				if (ct->dead || ct->negative)
+				if (local_ct->dead || local_ct->negative)
 					continue;	/* ignore dead and negative entries */
 
-				if (ct->hash_value != hashValue)
+				if (local_ct->hash_value != hashValue)
 					continue;	/* quickly skip entry if wrong hash val */
 
-				if (!ItemPointerEquals(&(ct->tuple.t_self), &(ntp->t_self)))
-					continue;	/* not same tuple */
+				if (cache->cc_type == CC_REGULAR)
+				{
+					if (!ItemPointerEquals(&(local_ct->tuple.t_self), &(ntp->t_self)))
+						continue;	/* not same tuple */
+				}
+				else if (cache->cc_type == CC_SHAREDLOCAL)
+				{
+					/*
+					 * ct is global cache entry or local uncommitted entry.
+					 * Refcount of global cache entry is bumped if it's valid.
+					 * If ct is NULL, ct is not valid and removed or marked
+					 * as dead.
+					 */
+					ct = LocalCacheGetValidEntry((LocalCatCTup *)local_ct);
+
+					if (CATC_IS_INVALID_DUMMY((LocalCatCTup *)local_ct))
+						continue;
+
+					if (ct)
+					{
+						if (!ItemPointerEquals(&(ct->tuple.t_self),
+											   &(ntp->t_self)))
+						{
+
+							/* Release refcount of unmatched global entry */
+							if (ct->my_cache->cc_type == CC_SHAREDGLOBAL)
+								GlobalCatCTupDecrementAndRemove((GlobalCatCache *)ct->my_cache,
+																(GlobalCatCTup *)ct);
+
+								continue;	/* not same tuple */
+						}
+					}
+					else
+						continue;
+				}
+				else
+					elog(FATAL, "CatCList is not located in shared memory");
 
 				/*
 				 * Found a match, but can't use it if it belongs to another
 				 * list already
 				 */
-				if (ct->c_list)
+				if (local_ct->c_list)
 					continue;
 
 				found = true;
@@ -1680,16 +2274,74 @@ SearchCatCacheList(CatCache *cache,
 
 			if (!found)
 			{
-				/* We didn't find a usable entry, so make a new one */
-				ct = CatalogCacheCreateEntry(cache, ntp, arguments,
-											 hashValue, hashIndex,
-											 false);
+				Index global_hashIndex;
+				GlobalCatCTup *gct;
+				Handle* handle;
+
+				if (cache->cc_type == CC_REGULAR)
+				{
+					/* We didn't find a usable entry, so make a new one */
+					local_ct = CatalogCacheCreateEntry(cache, ntp, arguments,
+													   hashValue, hashIndex,
+													   false, NULL);
+				}
+				else if (cache->cc_type == CC_SHAREDLOCAL)
+				{
+					global_hashIndex = HASH_INDEX(hashValue,
+												  ((CatCache *)cache->gcp)->
+												  cc_nbuckets);
+
+					gct = (GlobalCatCTup *)
+						CatalogCacheCreateEntry((CatCache *)cache->gcp,
+												ntp, arguments,
+												hashValue, global_hashIndex,
+												false, NULL);
+
+					/*
+					 * If tuple is uncommitted, it's not in GlobalCatCache
+					 * and ct has tuple locally.
+					 */
+					if (gct)
+						handle = gct->gct_handle;
+					else
+						handle = NULL;
+
+					/*
+					 * Local cache entry stores keys but arguments are partial
+					 * key and committed local cache entry doen't
+					 * have heapTuple. So keys cannot point to heapTuple.
+					 * So fill in arguments fully here and copy them.
+					 */
+					for (i = 0; i < nkeys; i++)
+						lct_arguments[i] = arguments[i];
+
+					for (i = nkeys; i < cache->cc_nkeys; i++)
+					{
+						Datum		atp;
+						bool		isnull;
+
+						atp = heap_getattr(ntp,
+										   cache->cc_keyno[i],
+										   cache->cc_tupdesc,
+										   &isnull);
+						Assert(!isnull);
+						lct_arguments[i] = atp;
+					}
+
+					local_ct = CatalogCacheCreateEntry(cache, ntp, lct_arguments,
+													   hashValue, hashIndex,
+													   false, handle);
+
+				}
 			}
 
-			/* Careful here: add entry to ctlist, then bump its refcount */
-			/* This way leaves state correct if lappend runs out of memory */
-			ctlist = lappend(ctlist, ct);
-			ct->refcount++;
+			/* Careful here: add entry to ctlist, then bump its refcount
+			 * This way leaves state correct if lappend runs out of memory.
+			 * The refcount of global cache entry is already bumped in
+			 * LocalCacheGetValidEntry.
+			 */
+			ctlist = lappend(ctlist, local_ct);
+			local_ct->refcount++;
 		}
 
 		systable_endscan(scandesc);
@@ -1702,6 +2354,12 @@ SearchCatCacheList(CatCache *cache,
 		cl = (CatCList *)
 			palloc(offsetof(CatCList, members) + nmembers * sizeof(CatCTup *));
 
+		if (cache->cc_type == CC_REGULAR)
+			cl->shared_local_members = NULL;
+		else if (cache->cc_type == CC_SHAREDLOCAL)
+			cl->shared_local_members = (LocalCatCTup **)
+				palloc(nmembers * sizeof(LocalCatCTup *));
+
 		/* Extract key values */
 		CatCacheCopyKeys(cache->cc_tupdesc, nkeys, cache->cc_keyno,
 						 arguments, cl->keys);
@@ -1718,19 +2376,37 @@ SearchCatCacheList(CatCache *cache,
 	}
 	PG_CATCH();
 	{
-		foreach(ctlist_item, ctlist)
+		GlobalCatCTup *gct;
+		GlobalCatCache *gcp;
+
+		/* Release refernce of local and global cache entry if it exists */
+		if (cache->cc_type == CC_REGULAR)
+			ReleaseLocalCtlistItem(cache, ctlist);
+		else if (cache->cc_type == CC_SHAREDLOCAL)
 		{
-			ct = (CatCTup *) lfirst(ctlist_item);
-			Assert(ct->c_list == NULL);
-			Assert(ct->refcount > 0);
-			ct->refcount--;
-			if (
-#ifndef CATCACHE_FORCE_RELEASE
-				ct->dead &&
-#endif
-				ct->refcount == 0 &&
-				(ct->c_list == NULL || ct->c_list->refcount == 0))
-				CatCacheRemoveCTup(cache, ct);
+			/*
+			 * Release global cache entry. If it's uncommitted entry release
+			 * local refcount.
+			 */
+			foreach(ctlist_item, ctlist)
+			{
+				ct = (CatCTup *) lfirst(ctlist_item);
+
+				Assert(ct->c_list == NULL);
+				Assert(ct->refcount > 0);
+
+				lct = (LocalCatCTup *)ct;
+
+				if (lct->lct_committed)
+				{
+					gct = lct->lct_handle->entry;
+					gcp = (GlobalCatCache *)(((CatCTup *)gct)->my_cache);
+
+					GlobalCatCTupDecrementAndRemove(gcp, gct);
+				}
+				else
+					ReleaseLocalCtlistItem(cache, ctlist);
+			}
 		}
 
 		PG_RE_THROW();
@@ -1746,20 +2422,57 @@ SearchCatCacheList(CatCache *cache,
 	cl->hash_value = lHashValue;
 	cl->n_members = nmembers;
 
-	i = 0;
-	foreach(ctlist_item, ctlist)
+
+	if (cache->cc_type == CC_REGULAR)
 	{
-		cl->members[i++] = ct = (CatCTup *) lfirst(ctlist_item);
-		Assert(ct->c_list == NULL);
-		ct->c_list = cl;
-		/* release the temporary refcount on the member */
-		Assert(ct->refcount > 0);
-		ct->refcount--;
-		/* mark list dead if any members already dead */
-		if (ct->dead)
-			cl->dead = true;
+		i = 0;
+		foreach(ctlist_item, ctlist)
+		{
+			cl->members[i++] = ct = (CatCTup *) lfirst(ctlist_item);
+			Assert(ct->c_list == NULL);
+			ct->c_list = cl;
+			/* release the temporary refcount on the member */
+			Assert(ct->refcount > 0);
+			ct->refcount--;
+			/* mark list dead if any members already dead */
+			if (ct->dead)
+				cl->dead = true;
+		}
+		Assert(i == nmembers);
+	}
+	else if (cache->cc_type == CC_SHAREDLOCAL)
+	{
+		/* Set local cache entries to the list */
+		i = 0;
+		foreach(ctlist_item, ctlist)
+		{
+			ct = lfirst(ctlist_item);
+			cl->shared_local_members[i] = lct = (LocalCatCTup *)ct;
+
+			Assert(ct->c_list == NULL);
+			ct->c_list = cl;
+
+			/* release the temporary refcount on the member */
+			Assert(ct->refcount > 0);
+			ct->refcount--;
+
+			/* mark list dead if any members already dead */
+			if (ct->dead)
+				cl->dead = true;
+
+			/* Set global cache entries or uncommitted local one to the list */
+			if (lct->lct_committed)
+			{
+				cl->members[i] = (CatCTup *)lct->lct_handle->entry;
+				Assert(cl->members[i]->refcount > 0);
+			}
+			else
+				cl->members[i] = ct;
+
+			i++;
+		}
+		Assert(i == nmembers);
 	}
-	Assert(i == nmembers);
 
 	dlist_push_head(&cache->cc_lists, &cl->cache_elem);
 
@@ -1767,13 +2480,42 @@ SearchCatCacheList(CatCache *cache,
 	cl->refcount++;
 	ResourceOwnerRememberCatCacheListRef(CurrentResourceOwner, cl);
 
-	CACHE_elog(DEBUG2, "SearchCatCacheList(%s): made list of %d members",
+	CACHE_elog(DEBUG2, "SearchCatCacheList (%s): made list of %d members",
 			   cache->cc_relname, nmembers);
 
 	return cl;
 }
 
 /*
+ *	ReleaseLocalCtlistItem
+ *
+ *  Workhorse of SearchCatCacheList.
+ *	Decrement the temporarily raised reference count of each ctlist item.
+ */
+static void
+ReleaseLocalCtlistItem(CatCache *cache, List *ctlist)
+{
+	CatCTup		*ct;
+	ListCell 	*ctlist_item;
+
+	foreach(ctlist_item, ctlist)
+	{
+		ct = (CatCTup *) lfirst(ctlist_item);
+		Assert(ct->c_list == NULL);
+		Assert(ct->refcount > 0);
+		ct->refcount--;
+		if (
+#ifndef CATCACHE_FORCE_RELEASE
+			ct->dead &&
+#endif
+			ct->refcount == 0 &&
+			(ct->c_list == NULL || ct->c_list->refcount == 0))
+			CatCacheRemoveCTup(cache, ct);
+
+	}
+}
+
+/*
  *	ReleaseCatCacheList
  *
  *	Decrement the reference count of a catcache list.
@@ -1787,6 +2529,28 @@ ReleaseCatCacheList(CatCList *list)
 	list->refcount--;
 	ResourceOwnerForgetCatCacheListRef(CurrentResourceOwner, list);
 
+	/*
+	 * Decrement the reference count of global cache entry.
+	 * members[] points to global entry but cannot be cast to GlobalCatCTup
+	 * so traverse from shared_local_members
+	 */
+	if (list->shared_local_members)
+	{
+		GlobalCatCTup *gct;
+		GlobalCatCache *gcp;
+
+		for (int i = 0; i < list->n_members; i++)
+		{
+			if (!list->shared_local_members[i]->lct_committed)
+				continue;
+
+			gct = (GlobalCatCTup *)list->members[i];
+			gcp = (GlobalCatCache *)list->members[i]->my_cache;
+
+			GlobalCatCTupDecrementAndRemove(gcp, gct);
+		}
+	}
+
 	if (
 #ifndef CATCACHE_FORCE_RELEASE
 		list->dead &&
@@ -1804,77 +2568,126 @@ ReleaseCatCacheList(CatCList *list)
 static CatCTup *
 CatalogCacheCreateEntry(CatCache *cache, HeapTuple ntp, Datum *arguments,
 						uint32 hashValue, Index hashIndex,
-						bool negative)
+						bool negative, Handle* handle)
 {
 	CatCTup    *ct;
-	HeapTuple	dtp;
-	MemoryContext oldcxt;
+	MemoryContext oldcxt = NULL;
+	MemoryContext TempGlobalCatCacheContext = NULL;
+	LWLock *bucket_lock = NULL;
+	int i;
+	LocalCatCTup *lct;
+	GlobalCatCTup *gct;
+
 
-	/* negative entries have no tuple associated */
-	if (ntp)
+	/* Allocate memory for CatCTup and the cached tuple in one go */
+	if (cache->cc_type == CC_REGULAR || cache->cc_type == CC_SHAREDLOCAL)
+		oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
+	else if (cache->cc_type == CC_SHAREDGLOBAL)
 	{
-		int			i;
+			TempGlobalCatCacheContext = MemoryContextClone(GlobalCatCacheContext,
+														   CurrentMemoryContext);
 
-		Assert(!negative);
+		oldcxt = MemoryContextSwitchTo(TempGlobalCatCacheContext);
+	}
 
-		/*
-		 * If there are any out-of-line toasted fields in the tuple, expand
-		 * them in-line.  This saves cycles during later use of the catcache
-		 * entry, and also protects us against the possibility of the toast
-		 * tuples being freed before we attempt to fetch them, in case of
-		 * something using a slightly stale catcache entry.
-		 */
-		if (HeapTupleHasExternal(ntp))
-			dtp = toast_flatten_tuple(ntp, cache->cc_tupdesc);
+	if (cache->cc_type == CC_REGULAR)
+	{
+		if (ntp)
+			ct = CreateCatCTupWithTuple(cache, ntp);
 		else
-			dtp = ntp;
+			ct = CreateCatCTupWithoutTuple(cache, arguments);
+	}
+	else if (cache->cc_type == CC_SHAREDLOCAL)
+	{
+		if (ntp)
+		{
+			/*
+			 * If the tuple is made by its own transaction (not committed
+			 * yet), the entry should not be placed in Global CatCache
+			 * hash table to prevent other process from seeing uncommitted
+			 * cache entry. So just put it in local hash table.
+			 */
+			if (HeapTupleHeaderXminCommitted(ntp->t_data))
+			{
+				/* Create local tuple, which has keys but doesn't tuple */
+				ct = CreateCatCTupWithoutTuple(cache, arguments);
+				lct =  (LocalCatCTup *) ct;
+				lct->lct_committed = true;
+
+				Assert(handle);
+				Assert(!handle->free);
+				lct->lct_handle = handle;
+				lct->lct_generation = handle->generation;
+				lct->lct_skip_global_subxid = InvalidSubTransactionId;
+			}
+			else
+			{
+				/*
+				 * Assume global cache entry and its handle doesn't exist,
+				 * because we get uncommitted tuple.
+				 */
+				Assert(!handle);
 
-		/* Allocate memory for CatCTup and the cached tuple in one go */
-		oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
+				ct = CreateCatCTupWithTuple(cache, ntp);
+				lct = (LocalCatCTup *) ct;
 
-		ct = (CatCTup *) palloc(sizeof(CatCTup) +
-								MAXIMUM_ALIGNOF + dtp->t_len);
-		ct->tuple.t_len = dtp->t_len;
-		ct->tuple.t_self = dtp->t_self;
-		ct->tuple.t_tableOid = dtp->t_tableOid;
-		ct->tuple.t_data = (HeapTupleHeader)
-			MAXALIGN(((char *) ct) + sizeof(CatCTup));
-		/* copy tuple contents */
-		memcpy((char *) ct->tuple.t_data,
-			   (const char *) dtp->t_data,
-			   dtp->t_len);
-		MemoryContextSwitchTo(oldcxt);
+				lct->lct_committed = false;
+				lct->lct_handle = NULL;
+				lct->lct_generation = 0;
+				lct->lct_skip_global_subxid = InvalidSubTransactionId;
+			}
+		}
+		else
+		{
+			/* Negative cache is not in shared memory */
+			Assert(!handle);
 
-		if (dtp != ntp)
-			heap_freetuple(dtp);
+			/* Negative cache case */
+			ct = CreateCatCTupWithoutTuple(cache, arguments);
+			lct = (LocalCatCTup *) ct;
+
+			lct->lct_committed = false;
+			lct->lct_handle = NULL;
+			lct->lct_generation = 0;
+
+			/* inval_tuple doesn't have information about keys */
+			if (arguments)
+				lct->lct_skip_global_subxid = InvalidSubTransactionId;
+			else
+				lct->lct_skip_global_subxid = GetCurrentSubTransactionId();
 
-		/* extract keys - they'll point into the tuple if not by-value */
-		for (i = 0; i < cache->cc_nkeys; i++)
-		{
-			Datum		atp;
-			bool		isnull;
-
-			atp = heap_getattr(&ct->tuple,
-							   cache->cc_keyno[i],
-							   cache->cc_tupdesc,
-							   &isnull);
-			Assert(!isnull);
-			ct->keys[i] = atp;
 		}
 	}
-	else
+	else /* shared global */
 	{
-		Assert(negative);
-		oldcxt = MemoryContextSwitchTo(CacheMemoryContext);
-		ct = (CatCTup *) palloc(sizeof(CatCTup));
+		if (!ntp)
+			elog(FATAL, "Negative global cache entry is not supported");
 
 		/*
-		 * Store keys - they'll point into separately allocated memory if not
-		 * by-value.
+		 * If the tuple is made by its own transaction (not committed
+		 * yet), the entry should not be placed in Global CatCache
+		 * hash table to prevent other process from seeing uncommitted
+		 * cache entry. So return NULL.
 		 */
-		CatCacheCopyKeys(cache->cc_tupdesc, cache->cc_nkeys, cache->cc_keyno,
-						 arguments, ct->keys);
-		MemoryContextSwitchTo(oldcxt);
+		if (!HeapTupleHeaderXminCommitted(ntp->t_data))
+		{
+			ShmRetailContextMoveChunk(TempGlobalCatCacheContext,
+									  GlobalCatCacheContext);
+
+			MemoryContextSwitchTo(oldcxt);
+			return NULL;
+		}
+
+		ct =  CreateCatCTupWithTuple(cache, ntp);
+
+		gct = (GlobalCatCTup *)ct;
+
+		gct->gct_handle =
+			GetCacheHandle(&((GlobalCatCache *)cache)->gcc_handle_hdr,
+						   (void *)gct);
+
+		/* Initailize lock for GlobalCatCTup */
+		SpinLockInit(&gct->gct_mutex);
 	}
 
 	/*
@@ -1889,18 +2702,82 @@ CatalogCacheCreateEntry(CatCache *cache, HeapTuple ntp, Datum *arguments,
 	ct->negative = negative;
 	ct->hash_value = hashValue;
 
+	MemoryContextSwitchTo(oldcxt);
+
+	if (cache->cc_type == CC_SHAREDGLOBAL)
+	{
+		/* bump global refcount as soon as possible. No lock is needed here yet */
+		ct->refcount++;
+
+		CACHE_elog(DEBUG2, "CatalogCacheCreateEntry global refcount is bumped: %s, %d tuple %p",
+				   ct->my_cache->cc_relname, ct->refcount,
+				   &ct->tuple);
+
+		/* Get lock for bucket */
+		bucket_lock = GetCatCacheBucketLock((GlobalCatCache *)cache, hashValue);
+		LWLockAcquire(bucket_lock, LW_EXCLUSIVE);
+		hashIndex = HASH_INDEX(hashValue, cache->cc_nbuckets);
+	}
+
+	/* Now insert entry to hash table */
 	dlist_push_head(&cache->cc_bucket[hashIndex], &ct->cache_elem);
 
+	if (cache->cc_type == CC_SHAREDGLOBAL)
+	{
+		ShmRetailContextMoveChunk(TempGlobalCatCacheContext, GlobalCatCacheContext);
+		LWLockRelease(bucket_lock);
+		SpinLockAcquire(&((GlobalCatCache *)cache)->gcc_mutex);
+	}
+
 	cache->cc_ntup++;
-	CacheHdr->ch_ntup++;
+
+	if (cache->cc_type == CC_SHAREDGLOBAL)
+		SpinLockRelease(&((GlobalCatCache *)cache)->gcc_mutex);
+	else
+		CacheHdr->ch_ntup++;
 
 	/*
 	 * If the hash table has become too full, enlarge the buckets array. Quite
 	 * arbitrarily, we enlarge when fill factor > 2.
 	 */
 	if (cache->cc_ntup > cache->cc_nbuckets * 2)
+	{
+		GlobalCatCache *gcp;
+		LWLock *old_bucket_locks = NULL;
+		int num_locks;
+
+		/* Enlarge bucket locks as well */
+		if (cache->cc_type == CC_SHAREDGLOBAL)
+		{
+			gcp = (GlobalCatCache *) cache;
+
+			/* bucket locks will be changed after rehasing */
+
+			old_bucket_locks = gcp->gcc_bucket_locks;
+			num_locks = MAX_CC_BUCKET_LOCKS;
+
+			for (i = 0; i < num_locks; ++i)
+				LWLockAcquire(&old_bucket_locks[i], LW_EXCLUSIVE);
+
+			/* other process might already enlarge the hash table */
+			if (cache->cc_ntup <= cache->cc_nbuckets * 2)
+			{
+				/* Release locks in reverse order */
+				for (i = num_locks - 1 ; i >= 0; --i)
+					LWLockRelease(&old_bucket_locks[i]);
+			}
+		}
+
 		RehashCatCache(cache);
 
+		if (cache->cc_type == CC_SHAREDGLOBAL)
+		{
+			/* Release locks in reverse order */
+			for (i = num_locks - 1 ; i >= 0; --i)
+				LWLockRelease(&old_bucket_locks[i]);
+		}
+	}
+
 	return ct;
 }
 
@@ -2076,6 +2953,9 @@ PrintCatCacheLeakWarning(HeapTuple tuple)
 	/* Safety check to ensure we were handed a cache entry */
 	Assert(ct->ct_magic == CT_MAGIC);
 
+	/* CC_SHAREDLOCAL is ok if it's uncommitted tuple */
+	Assert(ct->my_cache->cc_type != CC_SHAREDGLOBAL);
+
 	elog(WARNING, "cache reference leak: cache %s (%d), tuple %u/%u has count %d",
 		 ct->my_cache->cc_relname, ct->my_cache->id,
 		 ItemPointerGetBlockNumber(&(tuple->t_self)),
